"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rxme_1 = require("./rxme");
var LogLevel;
(function (LogLevel) {
    LogLevel["INFO"] = "info";
    LogLevel["WARN"] = "warn";
    LogLevel["ERROR"] = "error";
    LogLevel["DEBUG"] = "debug";
})(LogLevel = exports.LogLevel || (exports.LogLevel = {}));
class LogEntry {
    constructor(level, parts) {
        this.level = level;
        this.parts = parts;
    }
}
exports.LogEntry = LogEntry;
function Log(level, ...args) {
    return new rxme_1.RxMe(new LogEntry(level, args));
}
exports.Log = Log;
function LogInfo(...args) {
    return Log(LogLevel.INFO, ...args);
}
exports.LogInfo = LogInfo;
function LogWarn(...args) {
    return Log(LogLevel.WARN, ...args);
}
exports.LogWarn = LogWarn;
function LogDebug(...args) {
    return Log(LogLevel.DEBUG, ...args);
}
exports.LogDebug = LogDebug;
function LogError(...args) {
    return Log(LogLevel.ERROR, ...args);
}
exports.LogError = LogError;
exports.default = LogEntry;
//# sourceMappingURL=log.js.map