import { Subject, RxMe } from './rxme';
import { LogEntry } from './log';
export declare type MatchReturn = Subject | boolean | void;
export interface MatcherCallback {
    (data: RxMe, sub: Subject): MatchReturn;
}
export interface LogEntryMatcherCallback {
    (lm: LogEntry, sub?: Subject): MatchReturn;
}
export declare class Matcher {
    static TypeOf<T>(typeOf: string, cb: (lm: T, sub?: Subject) => MatchReturn): MatcherCallback;
    static Number(cb: (lm: number, sub?: Subject) => MatchReturn): MatcherCallback;
    static Boolean(cb: (lm: boolean, sub?: Subject) => MatchReturn): MatcherCallback;
    static WildCard(cb: MatcherCallback): MatcherCallback;
    static Error(cb: (err: any, sub?: Subject) => MatchReturn): MatcherCallback;
    static Done(cb: (res: boolean, sub?: Subject) => MatchReturn): MatcherCallback;
    static Complete(cb: (sub?: Subject) => MatchReturn): MatcherCallback;
    static Type<T>(typ: any, cb: (t: T, sub?: Subject) => MatchReturn): MatcherCallback;
    static Log(cb: LogEntryMatcherCallback): MatcherCallback;
}
