"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const log_1 = require("./log");
const messages_1 = require("./messages");
class Matcher {
    static TypeOf(typeOf, cb) {
        return (rxme, sub) => {
            if (typeof (rxme.data) == typeOf) {
                return cb(rxme.data, sub);
            }
            return false;
        };
    }
    static Number(cb) {
        return this.TypeOf('number', cb);
    }
    static Boolean(cb) {
        return this.TypeOf('boolean', cb);
    }
    static WildCard(cb) {
        return cb;
    }
    static Error(cb) {
        return (rxme, sub) => {
            if (rxme.data instanceof messages_1.ErrorContainer) {
                return cb(rxme.data.error, sub);
            }
            return false;
        };
    }
    static Done(cb) {
        return (rxme, sub) => {
            console.log('Done:', rxme);
            if (rxme.data instanceof messages_1.DoneMsg) {
                return cb(rxme.data.result, sub);
            }
            return false;
        };
    }
    static Complete(cb) {
        return (rxme, sub) => {
            if (rxme.data instanceof messages_1.CompleteMsg) {
                return cb(sub);
            }
            return false;
        };
    }
    static Type(typ, cb) {
        return (rxme, sub) => {
            if (rxme.data instanceof typ) {
                return cb(rxme.data, sub);
            }
            return false;
        };
    }
    static Log(cb) {
        return (rxme, sub) => {
            const ret = rxme.data instanceof log_1.LogEntry;
            if (ret) {
                return cb(rxme.data, sub);
            }
            return false;
        };
    }
}
exports.Matcher = Matcher;
//# sourceMappingURL=matcher.js.map