"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rxme_1 = require("./rxme");
const Log = require("./log");
const messages_1 = require("./messages");
class DoneMsg {
    constructor(result) {
        this.done = result;
    }
}
exports.DoneMsg = DoneMsg;
class Msg {
    static Number(nr) {
        return new rxme_1.RxMe(nr);
    }
    static Boolean(is) {
        return new rxme_1.RxMe(is);
    }
    static Done(result) {
        return new rxme_1.RxMe(new DoneMsg(result));
    }
    static Complete() {
        return new rxme_1.RxMe(new messages_1.CompleteMsg());
    }
    static Type(t) {
        return new rxme_1.RxMe(t);
    }
    static Log(level, ...arg) {
        return Log.Log(level, arg);
    }
    static LogInfo(...arg) {
        return Log.LogInfo(arg);
    }
    static LogWarn(...arg) {
        return Log.LogWarn(arg);
    }
    static LogDebug(...arg) {
        return Log.LogDebug(arg);
    }
    static LogError(...arg) {
        return Log.LogError(arg);
    }
    static Error(...arg) {
        return new rxme_1.RxMe(new messages_1.ErrorContainer(arg.length == 1 ? arg[0] : arg));
    }
}
exports.Msg = Msg;
exports.default = Msg;
//# sourceMappingURL=msg.js.map