import * as rx from 'rxjs';
export * from './log';
export * from './matcher';
export * from './msg';
import { MatcherCallback } from './matcher';
export declare class MatcherMixin {
    readonly objectId: string;
    readonly obss: Observer[];
    readonly matcher: MatcherCallback[];
    readonly _completed: MatcherCallback[];
    private subscription;
    constructor();
    passTo(sbj: Subject, obs?: Observer | Observer[]): void;
    match(cb: MatcherCallback): void;
    completed(cb: MatcherCallback): void;
}
export declare class Subject extends rx.Subject<RxMe> {
    private readonly mixin;
    constructor();
    completed(cb: MatcherCallback): Subject;
    pass(result: boolean): Subject;
    passTo(obs?: Observer | Observer[]): Subject;
    match(cb: MatcherCallback): Subject;
}
export interface Observer extends rx.Observer<RxMe> {
}
export interface ObserverCb {
    (_: Observer): any;
}
export declare class Observable {
    private readonly observerCb;
    private subject;
    static create(obsCb: ObserverCb): Observable;
    constructor(obsCb: ObserverCb);
    match(cb: MatcherCallback): Observable;
    completed(cb: MatcherCallback): Observable;
    passTo(pobs?: Observer | Observer[]): Observable;
}
export declare class RxMe {
    readonly objectId: string;
    readonly data: any;
    constructor(_data: any);
}
export default RxMe;
