"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
const rx = require("rxjs");
// import Error from './error';
// export { Error } from './error';
__export(require("./log"));
// import { LogEntry, LogLevel } from './log-msg';
__export(require("./matcher"));
__export(require("./msg"));
// export { Data } from './data';
const msg_1 = require("./msg");
const matcher_1 = require("./matcher");
const messages_1 = require("./messages");
// export enum Match {
//   NUMBER = 'number',
//   BOOLEAN = 'boolean',
//   STRING = 'string',
//   OBJECT = 'object'
// }
// export class Matcher<T> {
//   public readonly type: any;
//   public readonly cb: MatcherCallback<T>;
//   constructor(type: any, cb: MatcherCallback<T>) {
//     this.type = type;
//     this.cb = cb;
//   }
// }
// export class Done {
//   public readonly result: boolean;
//   constructor(result: boolean) {
//     this.result = result;
//   }
// }
// export class Complete {
// }
class MatcherMixin {
    constructor() {
        // this.type = a;
        this.obss = [];
        this.matcher = [];
        this._completed = [];
        this.objectId = ('' + (1000000000 + ~~(Math.random() * 1000000000))).slice(1);
    }
    passTo(sbj, obs = null) {
        let obss = [];
        if (obs instanceof Array) {
            obss = obs;
        }
        else if (obs) {
            obss = [obs];
        }
        // if (!!obss.find(o => !o)) {
        // console.error(`[${this.objectId}]:NULL:obss`);
        // }
        this.obss.push.apply(this.obss, obss);
        // console.log(`[${obss}]:[${this.obss}]`);
        if (!this.subscription) {
            // console.log(`[${this.objectId}]:passTo:[${this.subscription}]`);
            this.subscription = sbj.subscribe(myobs => {
                // console.log(`[${this.objectId}]:Matcher:${JSON.stringify(myobs)}`);
                searchMatcher(this, 0, myobs, false);
            }, (err) => {
                // console.log('passTo:Error', err);
                searchMatcher(this, 0, msg_1.default.Error(err), false);
            }, () => {
                // console.log('passTo:Completed');
                searchMatcher(this, 0, msg_1.default.Complete(), false);
            });
        }
    }
    match(cb) {
        this.matcher.push(cb);
        // console.log('Match:', this.objectId, this.matcher.length);
        // this make the wildcard the last in match chain
        // const swap = this.matcher[this.matcher.length - 1];
        // this.matcher[this.matcher.length - 1] = this.matcher[this.matcher.length - 2];
        // this.matcher[this.matcher.length - 2] = swap;
        // console.log('Match:push:', this.matcher.length);
    }
    completed(cb) {
        this._completed.push(cb);
    }
}
exports.MatcherMixin = MatcherMixin;
class Subject extends rx.Subject {
    // public nextLog: Logger<T>;
    constructor() {
        // const a = new T();
        super();
        this.mixin = new MatcherMixin();
        // this.nextLog = new Logger(this);
    }
    completed(cb) {
        this.mixin.completed(cb);
        return this;
    }
    pass(result) {
        this.next(msg_1.default.Boolean(result));
        return this;
    }
    passTo(obs = null) {
        this.mixin.passTo(this, obs);
        return this;
    }
    match(cb) {
        this.mixin.match(cb);
        return this;
    }
}
exports.Subject = Subject;
class Observable {
    static create(obsCb) {
        const ret = new Observable(obsCb);
        return ret;
    }
    constructor(obsCb) {
        this.observerCb = obsCb;
        this.subject = new Subject();
    }
    match(cb) {
        this.subject.match(cb);
        return this;
    }
    // public matchType<A = T>(typ: any, cb: MatcherCallback<A>): Observable<T> {
    //   this.subject.matchType(typ, cb);
    //   return this;
    // }
    // public matchError(cb: MatcherCallback<Error>): Observable<T> {
    //   this.subject.matchType(Error, cb);
    //   return this;
    // }
    // public matchLogMsg(cb: MatcherCallback<LogMsg>): Observable<T> {
    //   this.subject.matchType(LogMsg, cb);
    //   return this;
    // }
    // public matchDone(cb: MatcherCallback<Done>): Observable<T> {
    //   this.subject.matchType(Done, cb);
    //   return this;
    // }
    // public matchComplete(cb: MatcherCallback<Complete>): Observable<T> {
    //   this.subject.matchType(Complete, cb);
    //   return this;
    // }
    // public wildCard(cb: MatcherCallback<any>): Observable<T> {
    //   this.subject.matchType(null, cb);
    //   return this;
    // }
    completed(cb) {
        this.subject.completed(cb);
        return this;
    }
    passTo(pobs = null) {
        this.subject.passTo(pobs);
        this.observerCb(this.subject);
        // this.subscribe(obs => {
        //   ret.next(obs);
        // });
        return this;
    }
}
exports.Observable = Observable;
class RxMe {
    constructor(_data) {
        this.objectId = ('' + (1000000000 + ~~(Math.random() * 1000000000))).slice(1);
        this.data = _data;
    }
}
exports.RxMe = RxMe;
// the lint has some problems with forward declarations
function searchMatcher(mymm, matcherIdx, rxme, dontPassTo) {
    // console.log(`[${this.objectId}]:enter:${!!this._done}`);
    if (matcherIdx >= mymm.matcher.length) {
        // console.log('Matcher:completed:', dontPassTo);
        if (!dontPassTo) {
            // console.log(mymm);
            mymm.obss.forEach(os => os.next(rxme));
        }
        mymm._completed.forEach(cd => cd(rxme, null));
        return;
    }
    const match = mymm.matcher[matcherIdx];
    // if (rxme.isKind(match.type)) {
    // if (obssIdx >= mymm.obss.length || (found && obssIdx == mymm.obss.length - 1)) {
    //   console.log(`Next:Matcher:`, matcherIdx, found);
    //   searchMatcher(mymm, matcherIdx + 1, 0, rxme, found);
    //   return;
    // }
    const doneFilter = new Subject();
    const isCompleted = rxme.data instanceof messages_1.CompleteMsg;
    const doneFilterSubscription = doneFilter.subscribe(obs => {
        matcher_1.Matcher.Boolean((pass) => {
            doneFilterSubscription.unsubscribe();
            // if (isCompleted && os) {
            //   os.next(rxme);
            //   // console.log('matchDone', this.objectId, os.objectId, isCompleted, rxme);
            // }
            // console.log(`Matcher:`, mymm.matcher.length, matcherIdx, dontPassTo, obs.data.done, !isCompleted);
            searchMatcher(mymm, matcherIdx + 1, rxme, !isCompleted && (dontPassTo || obs.data));
        })(obs, null);
    });
    // console.log(`${rxme.objectId}:${matcherIdx}:${isCompleted}:${JSON.stringify(rxme)}`);
    const o = match(rxme, doneFilter);
    if (o !== doneFilter) {
        doneFilter.pass(!!o);
    }
    // } else {
    //   searchMatcher(mymm, matcherIdx + 1, 0, rxme, found);
    // }
    // console.log(`[${this.objectId}]:leave:${!!this._done}`);
}
// export function data<T>(t: T): RxMe {
//   return new RxMe(t);
// }
// export function logMsg(level: LogLevel, ...parts: any[]): RxMe {
//   return data(new LogMsg(level, parts));
// }
// export function error(a: any): RxMe {
//   return data(new Error(a));
// }
// export function done(a: boolean): RxMe {
//   return data(new Done(a));
// }
// export function complete(): RxMe {
//   return data(new Complete());
// }
exports.default = RxMe;
//# sourceMappingURL=rxme.js.map